/*
		    TTTTTTT    OOOOO    7777777
		       T      O     O        7
		       T      O     O       7
		       T      O     O      7
		       T      O     O     7
		       T       OOOOO     7

			     EMULATEUR

			  Par Sylvain HUET
		(sylvain.huet@polytechnique.org)
				  1994-2002

  main.c : boucle principale et gestion windows

*/

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <Wingdi.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "resource.h"
#include "main.h"
#include "emuto7.h"
#include "monitor.h"
#include "video.h"
#include "sound.h"

int widthTO=320;
int heightTO=200;
int pixelsize=2;

HWND TOhwnd;
HMENU hmenu;
HBITMAP TObmp;
short * TObmppnt ;
DIBSECTION TObmpinfo ;


void TOrepaint()
{
	
    HDC Dcw , Dcb ;       
    HBITMAP OldBitmap ;
	int x,y,yb;

	ValidateRect(TOhwnd,NULL);
	
    Dcw=GetDC(TOhwnd);
    Dcb=CreateCompatibleDC(Dcw);
	OldBitmap = SelectObject(Dcb, TObmp);

	if (gettour())
	{
		BitBlt ( Dcw, 0,0,8*pixelsize,216*pixelsize, Dcb,0,0, SRCCOPY);
		BitBlt ( Dcw, 328*pixelsize,0,8*pixelsize,216*pixelsize, Dcb,328*pixelsize,0, SRCCOPY);
		BitBlt ( Dcw, 8*pixelsize,0,320*pixelsize,8*pixelsize, Dcb,8*pixelsize,0, SRCCOPY);
		BitBlt ( Dcw, 8*pixelsize,208*pixelsize,320*pixelsize,8*pixelsize, Dcb,8*pixelsize,208*pixelsize, SRCCOPY);
	}

	for(x=0;x<40;x++)
	{
		y=nextyfrombufchar(x,-1);
		while(y<25)
		{
			yb=fillfrombufchar(x,y);
			BitBlt ( Dcw, (8+x*8)*pixelsize, (8+y*8)*pixelsize, 8*pixelsize, (yb-y+1)*8*pixelsize, Dcb, (8+x*8)*pixelsize, (8+y*8)*pixelsize, SRCCOPY);
			y=nextyfrombufchar(x,yb);
		}
	}

//	BitBlt ( Dcw, 0, 0, widthTO*pixelsize, heightTO*pixelsize, Dcb, 0, 0, SRCCOPY);
	SelectObject ( Dcb , OldBitmap ) ;
	DeleteDC ( Dcb ) ;

	clrbufchar();
}

int TOinitBitmap ()
{
	BITMAPINFO Bi ;
	int tf ;
	HDC dc ;
	
	dc = NULL ;
	
	Bi.bmiHeader.biSize = sizeof ( BITMAPINFOHEADER ) ;
	Bi.bmiHeader.biWidth = (widthTO+16)*pixelsize ;
	
	Bi.bmiHeader.biHeight = - (heightTO+16)*pixelsize ;
	
	Bi.bmiHeader.biPlanes = 1 ;
	Bi.bmiHeader.biBitCount = 16 ;
	Bi.bmiHeader.biCompression = BI_RGB ;
	Bi.bmiHeader.biSizeImage = 0 ;
	Bi.bmiHeader.biXPelsPerMeter = 0 ;
	Bi.bmiHeader.biYPelsPerMeter = 0 ;
	Bi.bmiHeader.biClrUsed = 0 ;
	tf = DIB_RGB_COLORS ;
    Bi.bmiHeader.biClrImportant = Bi.bmiHeader.biClrUsed ;
	
	TObmp = CreateDIBSection ( dc , (BITMAPINFO * ) & Bi , tf , & TObmppnt , NULL , 0 ) ;
	
    if (TObmp == NULL ) return -1;
	
	GetObject ( TObmp , sizeof( DIBSECTION ) , &TObmpinfo ) ;
	return 0 ;              
}    

void TOresize(int i)
{
	RECT rc,rw;

	pixelsize=i;

	if (TObmp) DeleteObject(TObmp);
	TOinitBitmap();
	initoffpixel(pixelsize);

	for(i=0;i<40*200;i++) affcur(0x4000+i);
	resettour();
	GetClientRect(TOhwnd,&rc);
	GetWindowRect(TOhwnd,&rw);

	SetWindowPos(TOhwnd,HWND_TOP,rw.left,rw.top,
		pixelsize*(widthTO+16)+rw.right-rw.left-rc.right,
		pixelsize*(heightTO+16)+rw.bottom-rw.top-rc.bottom,
		0);
}

int movemouse(int x,int y)
{
	updatecray((x/pixelsize)-8,(y/pixelsize)-8);
	return 0;
}

int clickmouse(int x,int y,int state)
{
	updatecraypoint(state);
	return 0;
}

int openk7()
{
	OPENFILENAME ofn;
	char buf[_MAX_PATH];
	char pwd[_MAX_PATH];
	
	strcpy(buf,"");
	strcpy(pwd,"");
	GetCurrentDirectory(_MAX_PATH,pwd);
	
	ofn.Flags= OFN_HIDEREADONLY | OFN_CREATEPROMPT | OFN_EXPLORER;
	
	ofn.lStructSize       = sizeof (OPENFILENAME) ;
	ofn.hwndOwner         = TOhwnd ;
	ofn.hInstance         = NULL ;
	ofn.lpstrFilter       = "Fichiers k7 (*.k7)\0*.k7\0Tous les fichiers (*.*)\0*.*\0\0";
	ofn.lpstrCustomFilter = NULL ;
	ofn.nMaxCustFilter    = 0 ;
	ofn.nFilterIndex      = 0 ;
	ofn.lpstrFile         = buf ; 
	ofn.nMaxFile          = _MAX_PATH ;
	ofn.lpstrFileTitle    = NULL ; 
	ofn.nMaxFileTitle     = _MAX_FNAME + _MAX_EXT ;
	ofn.lpstrInitialDir   = pwd ;
	ofn.lpstrTitle        = NULL ;
	ofn.nFileOffset       = 0 ;
	ofn.nFileExtension    = 0 ;
	ofn.lpstrDefExt       = NULL ;
	ofn.lCustData         = 0L ;
	ofn.lpfnHook          = NULL ;
	ofn.lpTemplateName    = NULL ;
	if (!GetOpenFileName (&ofn)) return 0;
	
	newcass(ofn.lpstrFile);
	setbufchar();
	forcetour();
	return 0;
}

int openmemo7()
{
	OPENFILENAME ofn;
	char buf[_MAX_PATH];
	char pwd[_MAX_PATH];
	
	strcpy(buf,"");
	strcpy(pwd,"");
	GetCurrentDirectory(_MAX_PATH,pwd);
	
	ofn.Flags= OFN_HIDEREADONLY | OFN_CREATEPROMPT | OFN_EXPLORER;
	
	ofn.lStructSize       = sizeof (OPENFILENAME) ;
	ofn.hwndOwner         = TOhwnd ;
	ofn.hInstance         = NULL ;
	ofn.lpstrFilter       = "Memo7 (*.m7)\0*.m7\0Tous les fichiers (*.*)\0*.*\0\0";
	ofn.lpstrCustomFilter = NULL ;
	ofn.nMaxCustFilter    = 0 ;
	ofn.nFilterIndex      = 0 ;
	ofn.lpstrFile         = buf ; 
	ofn.nMaxFile          = _MAX_PATH ;
	ofn.lpstrFileTitle    = NULL ; 
	ofn.nMaxFileTitle     = _MAX_FNAME + _MAX_EXT ;
	ofn.lpstrInitialDir   = pwd ;
	ofn.lpstrTitle        = NULL ;
	ofn.nFileOffset       = 0 ;
	ofn.nFileExtension    = 0 ;
	ofn.lpstrDefExt       = NULL ;
	ofn.lCustData         = 0L ;
	ofn.lpfnHook          = NULL ;
	ofn.lpTemplateName    = NULL ;
	if (!GetOpenFileName (&ofn)) return 0;
	
	merge(ofn.lpstrFile,0);
	reset();
	setbufchar();
	forcetour();
	return 0;
}


int resetto7()
{
	reset();
	avanck7(0);
	return 0;
}

LRESULT CALLBACK WindowProc( HWND hwnd, unsigned msg,
							UINT wParam, LONG lParam )
{
	int wmId, wmEvent;

    switch( msg ) {
		
    case WM_DESTROY:
		StopSound();
		PostQuitMessage(0);
		break;
    case WM_PAINT:
		setbufchar();
		forcetour();
        TOrepaint();
        break;
    case WM_MOUSEMOVE :
		movemouse(LOWORD(lParam),HIWORD(lParam));
        break;
    case WM_LBUTTONDOWN :
		clickmouse(LOWORD(lParam),HIWORD(lParam),1);
		break;
    case WM_LBUTTONUP :
		clickmouse(LOWORD(lParam),HIWORD(lParam),0);
		break;
    case WM_KEYDOWN:
        newkeydown(wParam);
        break ;
    case WM_KEYUP:
        newkeyup(wParam);
        break ;
	case MM_WOM_DONE:
		SoundPlayEvent((int)hwnd,(int)msg,(int)wParam,(int)lParam);
		BeginSoundBuffer();
		if ((ifSoundOn())&&(isemurunning())) runemu();
		FinishSoundBuffer();

		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
			case IDM_MEMO7:
				openmemo7();
				break;
			case IDM_K7:
				openk7();
				break;
			case IDM_QUIT:
				DestroyWindow(TOhwnd);
				break;
			case IDM_SOUND:
				setnormalspeed();
				StartSound();
				CheckMenuItem (hmenu,IDM_SOUND , MF_BYCOMMAND | MF_CHECKED ) ;
				CheckMenuItem (hmenu,IDM_NOSOUND , MF_BYCOMMAND | MF_UNCHECKED ) ;
				CheckMenuItem (hmenu,IDM_SPEED , MF_BYCOMMAND | MF_UNCHECKED ) ;
				break;
			case IDM_NOSOUND:
				setnormalspeed();
				StopSound();
				CheckMenuItem (hmenu,IDM_SOUND , MF_BYCOMMAND | MF_UNCHECKED ) ;
				CheckMenuItem (hmenu,IDM_NOSOUND , MF_BYCOMMAND | MF_CHECKED ) ;
				CheckMenuItem (hmenu,IDM_SPEED , MF_BYCOMMAND | MF_UNCHECKED ) ;
				break;
			case IDM_SPEED:
				setmaxspeed();
				StopSound();
				CheckMenuItem (hmenu,IDM_SOUND , MF_BYCOMMAND | MF_UNCHECKED ) ;
				CheckMenuItem (hmenu,IDM_NOSOUND , MF_BYCOMMAND | MF_UNCHECKED ) ;
				CheckMenuItem (hmenu,IDM_SPEED , MF_BYCOMMAND | MF_CHECKED ) ;
				break;


			case IDM_ZOOM1:
				CheckMenuItem (hmenu,IDM_ZOOM1 , MF_BYCOMMAND | MF_CHECKED ) ;
				CheckMenuItem (hmenu,IDM_ZOOM2 , MF_BYCOMMAND | MF_UNCHECKED ) ;
				CheckMenuItem (hmenu,IDM_ZOOM3 , MF_BYCOMMAND | MF_UNCHECKED ) ;
				TOresize(1);
				break;
			case IDM_ZOOM2:
				CheckMenuItem (hmenu,IDM_ZOOM1 , MF_BYCOMMAND | MF_UNCHECKED ) ;
				CheckMenuItem (hmenu,IDM_ZOOM2 , MF_BYCOMMAND | MF_CHECKED ) ;
				CheckMenuItem (hmenu,IDM_ZOOM3 , MF_BYCOMMAND | MF_UNCHECKED ) ;
				TOresize(2);
				break;
			case IDM_ZOOM3:
				CheckMenuItem (hmenu,IDM_ZOOM1 , MF_BYCOMMAND | MF_UNCHECKED ) ;
				CheckMenuItem (hmenu,IDM_ZOOM2 , MF_BYCOMMAND | MF_UNCHECKED ) ;
				CheckMenuItem (hmenu,IDM_ZOOM3 , MF_BYCOMMAND | MF_CHECKED ) ;
				TOresize(3);
				break;
			case IDM_RESET:
				resetto7();
				break;
			case IDM_ABOUT:
				MessageBox(TOhwnd,TEXT("FunzyTO7-win32\n\npar Sylvain HUET\n\n2002, V2.0"),TEXT("FunzyTO7"),MB_OK);
				break;
			case IDM_COMMAND:
				MessageBox(TOhwnd,TEXT("FunzyTO7-win32\n\n\
Manette 0 : F1,F2,F11,F12 / Ctrl\n\
Manette 1 : F3,F4,F9,F10 / Shift\n"),TEXT("FunzyTO7"),MB_OK);
				break;
			default:
				return DefWindowProc(hwnd, msg, wParam, lParam);
		}
		break;
		
    default:
        return( DefWindowProc( hwnd, msg, wParam, lParam ) );
    }
	
	//    return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	
	return 0;
}


int TOinitWindow(HANDLE this_inst,int cmdshow)
{
    RECT r;
	char* caption;

	r.left=0;
	r.top=0;
	r.right=widthTO;
	r.bottom=heightTO;
    AdjustWindowRect(&r,WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,FALSE);
#ifdef TO770
	caption="FunzyTo7-70";
#else
	caption="FunzyTo7";
#endif
	TOhwnd = CreateWindow(
        "GenericClass",         /* class */
        caption,
        WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,    /* style */
        CW_USEDEFAULT,          /* init. x pos */
        CW_USEDEFAULT,          /* init. y pos */
		r.right-r.left,
		r.bottom-r.top,
        NULL,                   /* parent window */
        NULL,                   /* menu handle */
        this_inst,               /* program handle */
        NULL                    /* create parms */
        );
    if (!TOhwnd) return -1;
    
    ShowWindow(TOhwnd,cmdshow);
    UpdateWindow(TOhwnd);

	hmenu=LoadMenu(this_inst,MAKEINTRESOURCE(IDR_MENU1));
	SetMenu(TOhwnd,hmenu);
	TOresize(2);

	return 0;
}


static BOOL AnyInstance( HANDLE this_inst, HANDLE prev_inst, int cmdshow, LPSTR cmdline )
{
	if (TOinitBitmap ()) return FALSE;
	if (TOinitWindow(this_inst,cmdshow)) return FALSE;
	initemu();
	launchemu();
	StartSound();
    return TRUE;                       
}

static BOOL FirstInstance( HANDLE this_inst )
{
    WNDCLASS    wc;
    BOOL        rc;
	
    wc.style = CS_HREDRAW | CS_VREDRAW |CS_OWNDC |CS_DBLCLKS;
    wc.lpfnWndProc = (LPVOID) WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = sizeof( DWORD );
    wc.hInstance = this_inst;
    wc.hIcon = LoadIcon(this_inst,IDI_APPLICATION );
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
    wc.hbrBackground = GetSysColorBrush(COLOR_MENU);//COLOR_APPWORKSPACE);//COLOR_BACKGROUND;
    wc.lpszMenuName = "GenericMenu";
    wc.lpszClassName = "GenericClass";
    rc = RegisterClass( &wc );
	
    return( rc );
}

int PASCAL WinMain( HINSTANCE this_inst, HINSTANCE prev_inst, LPSTR cmdline,
				   int cmdshow)
{
	MSG         msg;
	
    if( !prev_inst ) {
        if( !FirstInstance( this_inst ) ) return( FALSE );
    }
    if( !AnyInstance( this_inst, prev_inst, cmdshow, cmdline ) ) return( FALSE );
	
	
	while(1)
	{
		if ((isemurunning())&&(!ifSoundOn()))
		{
			while (PeekMessage(&msg, NULL,  0, 0, PM_REMOVE))   
			{
				if (msg.message==WM_QUIT) return msg.wParam;
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
			if (!shouldwait()) runemu();
		}
		else
		{
			if ( GetMessage( &msg, NULL, 0, 0 ) )
			{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
			else return ( msg.wParam );
		}
	}
    return 0;
}


